//////////////////////////////////////////////////////////////
//
//  Description	: PDF2HTML/BMP software
//  Author	: verypdf.com Inc
//  Version	: Ver1.2
//  Platform	: Windows95/98/Me/NT/2000/XP
//  Environment	: Visual C++ 6.0
//  Date	: 2002/04/03
//
//  Copyright(C) 2000--2003 verypdf.com Inc
//      
//  Contact infomation:
//        http://www.verypdf.com/
//        support@verypdf.com
//
//  This program is shareware; you can redistribute and/or 
//  modify it under the terms of the GNU General Public License.
//  See the GNU General Public License for more details.
//
//               Portion base on Xpdf code
//         Copyright 1996-2003 Glyph && Cog, LLC
//////////////////////////////////////////////////////////////

#ifndef __DATASTRU2_H__
#define __DATASTRU2_H__

#include <windows.h>

#define WM_PROCESSING	WM_USER+100

#define _TIMES_NEW_ROMAN_	0
#define _ARIAL_			1

#define TXT_BOLD			0x00000080L	//Bold
#define TXT_ITALIC			0x00000100L	//Italic
#define TXT_USEBOX			0x00000200L	//Use the Text Box to fix the text position

enum EPageConType {
	PAGE_NULL,
	PAGE_TEXT,
	PAGE_BMP,
	PAGE_TABLE,
	PAGE_LINE
};

struct SText  
{ 
	int     nPosX;
	int     nPosY;
	
	COLORREF nColor;
	int     nStyle;
	int     nWidth;
	int     nHeight;
	int     nFont;
	int     nSize;
	UINT    nSpace;
	int     nRetract;
	int     nRowNum;
	void* bigHZInfo;
	int     csContentLen;
	char*   csContent;
	
	SText()
	{
		nPosX = 0;
		nPosY = 0;
		nColor = 0;
		nStyle = 0;
		nFont = _TIMES_NEW_ROMAN_;
		nSize = 48;
		nSpace = 0x80008;
		nRetract = 0;
		nRowNum = 1;
		
		bigHZInfo = NULL; 
		csContentLen = 0;
		csContent = NULL;
	}
	~SText()
	{
		if(csContent!=NULL)
		{
			csContentLen=0;
			delete []csContent;
			csContent=NULL;
		}
		if(bigHZInfo!=NULL)
		{  
			delete bigHZInfo;
			bigHZInfo=NULL;
		}   
	}
};

struct SPicture
{
   int   nPosX;
   int   nPosY;

   int   nStyle;
   int   nWidth;
   int   nHeight;
   int   nLen;
   BYTE* pData;  

   SPicture()
   {
	   nPosX = 0;
	   nPosY = 0;

	   nStyle = 1;
	   pData = NULL;
	   nWidth = 0;
	   nHeight = 0;
	   nLen = 0;
   }
   ~SPicture()
   {
		if(pData != NULL)
		{
		   delete []pData;
		   pData = NULL;
		}
   }
};
 
struct SLine
{
	int	nStartX;
	int	nStartY;
	int	nWidthX;
	int	nWidthY;
	int	nLineWidth;
	COLORREF nColor;
	DWORD	nStyle;

	SLine()
	{
		nStartX = 0;
		nStartY = 0;
		nWidthX = 0;
		nWidthY = 0;
		nLineWidth = 1;
		nColor = 0;
		nStyle = 0;
	}
};

struct SBlock
{
	EPageConType nBlockType;
	union{
		SPicture* pBitmap;
		SText*    pText;
		void*   pTable;
		SLine*	  pLine;
        }pBlockEntity;
	
	POINT GetPos();		
	
	SBlock()
	{
		nBlockType = PAGE_NULL;
		pBlockEntity.pBitmap = NULL;
	}
	~SBlock()
	{
		if(pBlockEntity.pBitmap!=NULL)
		{
			if(nBlockType==PAGE_BMP)
			{
				delete pBlockEntity.pBitmap;
			}
			else if(nBlockType==PAGE_TABLE)
			{
				delete pBlockEntity.pTable;
			}
			else if(nBlockType==PAGE_TEXT)
			{
				delete pBlockEntity.pText;
			}
			else if(nBlockType==PAGE_LINE)
			{
				delete pBlockEntity.pLine;
			}
			pBlockEntity.pText = NULL;
		}//end if
	}//end ~this
};

struct SPage
{
	int   nWidth, nHeight;
	int   nDPI;
	int   nBlockNum;
	SBlock *pBlock;

	SPage* NextPage;
	SPage()
	{
		nWidth = 2480;
		nHeight = 3508;
		nDPI = 300;
		nBlockNum = 0;
		pBlock = NULL;
		NextPage = NULL;
	}
	~SPage()
	{
		if(pBlock!=NULL)
		{
			delete []pBlock;
			pBlock = NULL;
			nBlockNum = 0;
		}
		if(NextPage!=NULL)
		{
			delete NextPage;
			NextPage = NULL;
		}
	}
};
#endif