//////////////////////////////////////////////////////////////
//
//  Description	: PDF2HTML/BMP software
//  Author	: verypdf.com Inc
//  Version	: Ver1.2
//  Platform	: Windows95/98/Me/NT/2000/XP
//  Environment	: Visual C++ 6.0
//  Date	: 2002/04/03
//
//  Copyright(C) 2000--2003 verypdf.com Inc
//      
//  Contact infomation:
//        http://www.verypdf.com/
//        support@verypdf.com
//
//  This program is shareware; you can redistribute and/or 
//  modify it under the terms of the GNU General Public License.
//  See the GNU General Public License for more details.
//
//               Portion base on Xpdf code
//         Copyright 1996-2003 Glyph && Cog, LLC
//////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "win_pdf2rtf.h"
#include "Html2pdf.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHtml2pdf property page

IMPLEMENT_DYNCREATE(CHtml2pdf, CPropertyPage)

CHtml2pdf::CHtml2pdf() : CPropertyPage(CHtml2pdf::IDD)
{
	//{{AFX_DATA_INIT(CHtml2pdf)
	m_charSpace = 0;
	m_bUseTextBox = FALSE;
	m_bAutoSpace = TRUE;
	m_bMergeRows = FALSE;
	m_bDeleteLineBreaks = FALSE;
	//}}AFX_DATA_INIT
}

CHtml2pdf::~CHtml2pdf()
{
}

void CHtml2pdf::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHtml2pdf)
	DDX_Control(pDX, IDC_SPIN_SPACE, m_ctrlSpinSpace);
	DDX_Text(pDX, IDC_EDIT_SPACES, m_charSpace);
	DDV_MinMaxInt(pDX, m_charSpace, 0, 200);
	DDX_Check(pDX, IDC_CHECK_USETEXTBOX, m_bUseTextBox);
	DDX_Check(pDX, IDC_CHECK_AUTOSPACE, m_bAutoSpace);
	DDX_Check(pDX, IDC_CHECK_ROWTEXTBLOCK, m_bMergeRows);
	DDX_Check(pDX, IDC_CHECK_DELETELINEBREAKS, m_bDeleteLineBreaks);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CHtml2pdf, CPropertyPage)
	//{{AFX_MSG_MAP(CHtml2pdf)
	ON_BN_CLICKED(IDC_CHECK_USETEXTBOX, OnCheckUsetextbox)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHtml2pdf message handlers

BOOL CHtml2pdf::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	char szCurDir[_MAX_PATH];
	GetModuleFileName(NULL, szCurDir, _MAX_PATH);
	CString t = szCurDir;
	int pos = t.ReverseFind('\\');
	strInitFileName = t.Left(pos+1) + "config.ini";
	m_charSpace = GetPrivateProfileInt("PDF2Word","CharSpaces",100,strInitFileName);

	m_ctrlSpinSpace.SetBuddy(GetDlgItem(IDC_EDIT_SPACES));
	m_ctrlSpinSpace.SetRange(0,200);

	m_bUseTextBox = AfxGetApp()->GetProfileInt("m_bUseTextBox","Flag",1);
	m_bAutoSpace = AfxGetApp()->GetProfileInt("m_bAutoSpace","Flag",m_bAutoSpace);

	m_bMergeRows = AfxGetApp()->GetProfileInt("CHtml2pdf","m_bMergeRows",TRUE);
	if(!m_bUseTextBox)
		m_bMergeRows = FALSE;
	m_bDeleteLineBreaks = AfxGetApp()->GetProfileInt("CHtml2pdf","m_bDeleteLineBreaks",FALSE);
	if(!m_bUseTextBox)
		m_bDeleteLineBreaks = FALSE;

	GetDlgItem(IDC_CHECK_ROWTEXTBLOCK)->EnableWindow(m_bUseTextBox);
	GetDlgItem(IDC_CHECK_DELETELINEBREAKS)->EnableWindow(m_bUseTextBox);

	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CHtml2pdf::SaveSetting()
{
	char buffer[50];
	sprintf(buffer,"%d",m_charSpace);
	WritePrivateProfileString("PDF2Word","CharSpaces",buffer,strInitFileName);
	AfxGetApp()->WriteProfileInt("m_bUseTextBox","Flag",m_bUseTextBox);
	AfxGetApp()->WriteProfileInt("m_bAutoSpace","Flag",m_bAutoSpace);
	AfxGetApp()->WriteProfileInt("CHtml2pdf","m_bMergeRows",m_bMergeRows);
	AfxGetApp()->WriteProfileInt("CHtml2pdf","m_bDeleteLineBreaks",m_bDeleteLineBreaks);
}

void CHtml2pdf::OnOK() 
{
	UpdateData(TRUE);
	SaveSetting();	
	CPropertyPage::OnOK();
}

void CHtml2pdf::OnCheckUsetextbox() 
{
	UpdateData(TRUE);
	GetDlgItem(IDC_CHECK_ROWTEXTBLOCK)->EnableWindow(m_bUseTextBox);
	GetDlgItem(IDC_CHECK_DELETELINEBREAKS)->EnableWindow(m_bUseTextBox);
	UpdateData(FALSE);
}
