//////////////////////////////////////////////////////////////
//
//  Description	: PDF2HTML/BMP software
//  Author	: verypdf.com Inc
//  Version	: Ver1.2
//  Platform	: Windows95/98/Me/NT/2000/XP
//  Environment	: Visual C++ 6.0
//  Date	: 2002/04/03
//
//  Copyright(C) 2000--2003 verypdf.com Inc
//      
//  Contact infomation:
//        http://www.verypdf.com/
//        support@verypdf.com
//
//  This program is shareware; you can redistribute and/or 
//  modify it under the terms of the GNU General Public License.
//  See the GNU General Public License for more details.
//
//               Portion base on Xpdf code
//         Copyright 1996-2003 Glyph && Cog, LLC
//////////////////////////////////////////////////////////////

#if !defined(AFX_MENUSPAWN_H__BB6F2F01_91FA_11D1_8B78_0000B43382FE__INCLUDED_)
#define AFX_MENUSPAWN_H__BB6F2F01_91FA_11D1_8B78_0000B43382FE__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CMenuSpawn  
{
public:
	CMenuSpawn();
	CMenuSpawn(BOOL _IsPopup);
	virtual ~CMenuSpawn();

	struct ToolBarData
	{ // struct for toolbar resource; guess you already know it ;)
		WORD wVersion;
		WORD wWidth;			
		WORD wHeight;			
		WORD wItemCount;		
	};
	struct SpawnItem
	{
		int	iImageIdx;
		int	iCmd;
		char	cText[128];
	};
	struct ImageItem
	{
		int		iImageIdx;
		int		iCmd;
	};
public:
	//ʼ
	void	Init(HINSTANCE hInstance);
	//Menuߵbmp bar
	VOID	SetBarImage(UINT nID,INT cx);
	//ͼ
	VOID	SetBackBitmap(const int iRes, COLORREF crBackColor);
	void	SetBackBitmap(const int iRes);

	BOOL	IsSpawnMenu(HMENU hMenu, const INT iItem, const BOOL bByPos);
	BOOL	GetMenuItemText(LPSTR csText,INT nSize,HMENU hMenu, const INT cmd, BOOL bByPos);
	VOID	TransparentBlt(HDC hDestDc,int x,int y,int w,int h,HBITMAP hBmp,int sx,int sy,COLORREF crTransparent);
	void	SetTextColor(const COLORREF crNormal, const COLORREF crSelected);
	BOOL	FindKeyboardShortcut(UINT nChar, UINT nFlags, HMENU hMenu, LRESULT &lRes);
	BOOL	SetFont(LOGFONT * lf);
	
	BOOL	MeasureItem(HWND hWnd,LPMEASUREITEMSTRUCT lpm);
	BOOL	DrawItem(LPDRAWITEMSTRUCT lp);
	INT	FindImageItem(const int cmd);
	SpawnItem * AddSpawnItem(const char * txt, const int cmd);
	VOID	RemapMenu(HMENU hMenu);
	VOID	AddImageItem(const int idx, WORD cmd);

	BOOL	LoadToolBarResource(unsigned int resId);
	BOOL	AddToolBarResource(unsigned int resId);
	void	EnableMenuItems(HMENU hMenu,HWND pParent);
public:
	RECT	oldMenuBarRc;
	BOOL	bMenuLooping;
public:
	HINSTANCE	hInst;
	HFONT		hMenuFont, hGuiFont;
	SIZE		szImage;
	HIMAGELIST	ilList;
	HIMAGELIST	ilOther;
//#ifdef HAS_MENU_LEFT_BMPBAR
	HIMAGELIST	m_BackImageList;
	INT		m_iBackImageWidth;
//#endif
	COLORREF	crMenuText, crMenuTextSel;
	COLORREF	cr3dFace, crMenu, crHighlight, cr3dHilight, cr3dShadow, crGrayText;
	COLORREF	m_clrBtnFace, m_clrBtnHilight, m_clrBtnShadow;

	INT		iSpawnItem;
	SpawnItem **	pSpawnItem;

	INT		iImageItem;
	ImageItem *	pImageItem;

	BOOL		bIsPopup;
	BOOL		bBackBitmap;
	HBITMAP		bmpBack;
};

BOOL	MenuPreTranslateMessage(CMenuSpawn& cSpawn,HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

#endif // !defined(AFX_MENUSPAWN_H__BB6F2F01_91FA_11D1_8B78_0000B43382FE__INCLUDED_)
