//////////////////////////////////////////////////////////////
//
//  Description	: PDF2HTML/BMP software
//  Author	: verypdf.com Inc
//  Version	: Ver1.2
//  Platform	: Windows95/98/Me/NT/2000/XP
//  Environment	: Visual C++ 6.0
//  Date	: 2002/04/03
//
//  Copyright(C) 2000--2003 verypdf.com Inc
//      
//  Contact infomation:
//        http://www.verypdf.com/
//        support@verypdf.com
//
//  This program is shareware; you can redistribute and/or 
//  modify it under the terms of the GNU General Public License.
//  See the GNU General Public License for more details.
//
//               Portion base on Xpdf code
//         Copyright 1996-2003 Glyph && Cog, LLC
//////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "win_pdf2rtf.h"
#include "OptionsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern BOOL	IsRegistered;
/////////////////////////////////////////////////////////////////////////////
// COptionsDlg dialog
IMPLEMENT_DYNCREATE(COptionsDlg, CPropertyPage)

COptionsDlg::COptionsDlg(CWnd* pParent /*=NULL*/)
	: CPropertyPage(COptionsDlg::IDD)
{
	//{{AFX_DATA_INIT(COptionsDlg)
	m_iPageZoom = 100;
	m_strPageZoom = _T("");
	m_iJPGQuality = 75;
	m_strJPGQuality = _T("");
	m_iPageRange = -1;
	m_iPageFrom = 1;
	m_iPageTo = 0;
	m_bPreview = FALSE;
	//}}AFX_DATA_INIT
}


void COptionsDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionsDlg)
	DDX_Control(pDX, IDC_COMBO_PAGERANGE, m_ctrlPageRange);
	DDX_Control(pDX, IDC_SLIDER_OUTPUTZOOM, m_ctrlPageZoom);
	DDX_Slider(pDX, IDC_SLIDER_OUTPUTZOOM, m_iPageZoom);
	DDX_Text(pDX, IDC_STATIC_PAGEZOOM, m_strPageZoom);
	DDX_CBIndex(pDX, IDC_COMBO_PAGERANGE, m_iPageRange);
	DDX_Text(pDX, IDC_EDIT_FROM, m_iPageFrom);
	DDV_MinMaxInt(pDX, m_iPageFrom, 1, 100000);
	DDX_Text(pDX, IDC_EDIT_TO, m_iPageTo);
	DDV_MinMaxInt(pDX, m_iPageTo, 1, 100000);
	DDX_Check(pDX, IDC_CHECK_OPENIT, m_bPreview);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptionsDlg, CPropertyPage)
	//{{AFX_MSG_MAP(COptionsDlg)
	ON_WM_HSCROLL()
	ON_CBN_SELCHANGE(IDC_COMBO_PAGERANGE, OnSelchangeComboPagerange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionsDlg message handlers

BOOL COptionsDlg::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	m_iPageZoom = AfxGetApp()->GetProfileInt("ZoomRatio","Zoom",100);
	m_ctrlPageZoom.SetRange(50,200,TRUE);
	m_ctrlPageZoom.SetPos(m_iPageZoom);

	m_iJPGQuality = AfxGetApp()->GetProfileInt("JpgQuality","Quality",75);
		
	m_strPageZoom.Format("%d%%",m_iPageZoom);
	m_strJPGQuality.Format("%d%%",m_iJPGQuality);

	m_iPageRange = AfxGetApp()->GetProfileInt("PageRangeType","Type",0);
	if(m_iPageRange == 0)
	{//All pages
		GetDlgItem(IDC_EDIT_FROM)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_TO)->EnableWindow(FALSE);
	}
	m_iPageFrom = AfxGetApp()->GetProfileInt("PageRange","From",1);
	m_iPageTo = AfxGetApp()->GetProfileInt("PageRange","To",100000);

	m_bPreview = AfxGetApp()->GetProfileInt("Preview","Flag",0);

	if(!IsRegistered)
	{
		GetDlgItem(IDC_STATIC_PAGEZOOM)->EnableWindow(FALSE);
		GetDlgItem(IDC_STATIC_ZOOM)->EnableWindow(FALSE);
		GetDlgItem(IDC_SLIDER_OUTPUTZOOM)->EnableWindow(FALSE);
	}
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void COptionsDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	UpdateData();
	CSliderCtrl *pSliderCtrl = (CSliderCtrl *)pScrollBar;
	if(pSliderCtrl == &m_ctrlPageZoom)
		m_strPageZoom.Format("%d%%",m_iPageZoom);
	else if(pSliderCtrl == &m_ctrlJPGQuality)
		m_strJPGQuality.Format("%d%%",m_iJPGQuality);
	UpdateData(FALSE);

	CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
}

void COptionsDlg::OnSelchangeComboPagerange() 
{
	UpdateData();
	GetDlgItem(IDC_EDIT_FROM)->EnableWindow(m_iPageRange==0?FALSE:TRUE);
	GetDlgItem(IDC_EDIT_TO)->EnableWindow(m_iPageRange==0?FALSE:TRUE);
}

void COptionsDlg::SaveSetting()
{
	AfxGetApp()->WriteProfileInt("PageRangeType","Type",m_iPageRange);
	AfxGetApp()->WriteProfileInt("PageRange","From",m_iPageFrom);
	AfxGetApp()->WriteProfileInt("PageRange","To",m_iPageTo);
	AfxGetApp()->WriteProfileInt("ZoomRatio","Zoom",m_iPageZoom);
	AfxGetApp()->WriteProfileInt("JpgQuality","Quality",m_iJPGQuality);
	AfxGetApp()->WriteProfileInt("Preview","Flag",m_bPreview);
}

void COptionsDlg::OnOK() 
{
	UpdateData(TRUE);
	SaveSetting();	
	CPropertyPage::OnOK();
}
