//////////////////////////////////////////////////////////////
//
//  Description	: PDF2HTML/BMP software
//  Author	: verypdf.com Inc
//  Version	: Ver1.2
//  Platform	: Windows95/98/Me/NT/2000/XP
//  Environment	: Visual C++ 6.0
//  Date	: 2002/04/03
//
//  Copyright(C) 2000--2003 verypdf.com Inc
//      
//  Contact infomation:
//        http://www.verypdf.com/
//        support@verypdf.com
//
//  This program is shareware; you can redistribute and/or 
//  modify it under the terms of the GNU General Public License.
//  See the GNU General Public License for more details.
//
//               Portion base on Xpdf code
//         Copyright 1996-2003 Glyph && Cog, LLC
//////////////////////////////////////////////////////////////

#ifdef __GNUC__
#pragma implementation
#endif

#include <aconf.h>
#include "SFont.h"

//------------------------------------------------------------------------

SFontEngine::SFontEngine(Display *displayA, Visual *visualA, int depthA,
			 Colormap colormapA) {
  display = displayA;
  visual = visualA;
  depth = depthA;
  colormap = colormapA;
}

SFontEngine::~SFontEngine() {
}

void SFontEngine::useTrueColor(int rMaxA, int rShiftA, int gMaxA, int gShiftA,
			       int bMaxA, int bShiftA) {
  trueColor = gTrue;
  rMax = rMaxA;
  rShift = rShiftA;
  gMax = gMaxA;
  gShift = gShiftA;
  bMax = bMaxA;
  bShift = bShiftA;
}

void SFontEngine::useColorCube(Gulong *colorsA, int nRGBA) {
  trueColor = gFalse;
  colors = colorsA;
  nRGB = nRGBA;
  rMax = gMax = bMax = nRGB - 1;
}

Gulong SFontEngine::findColor(int r, int g, int b) {
  int r1, g1, b1;
  Gulong pix;

  r1 = ((r & 0xffff) * rMax) / 0xffff;
  g1 = ((g & 0xffff) * gMax) / 0xffff;
  b1 = ((b & 0xffff) * bMax) / 0xffff;
  if (trueColor) {
    pix = (r1 << rShift) + (g1 << gShift) + (b1 << bShift);
  } else {
    pix = colors[(r1 * nRGB + g1) * nRGB + b1];
  }
  return pix;
}

//------------------------------------------------------------------------

SFontFile::SFontFile() {
}

SFontFile::~SFontFile() {
}

//------------------------------------------------------------------------

SFont::SFont() {
}

SFont::~SFont() {
}
