//////////////////////////////////////////////////////////////
//
//  Description	: PDF2HTML/BMP software
//  Author	: verypdf.com Inc
//  Version	: Ver1.2
//  Platform	: Windows95/98/Me/NT/2000/XP
//  Environment	: Visual C++ 6.0
//  Date	: 2002/04/03
//
//  Copyright(C) 2000--2003 verypdf.com Inc
//      
//  Contact infomation:
//        http://www.verypdf.com/
//        support@verypdf.com
//
//  This program is shareware; you can redistribute and/or 
//  modify it under the terms of the GNU General Public License.
//  See the GNU General Public License for more details.
//
//               Portion base on Xpdf code
//         Copyright 1996-2003 Glyph && Cog, LLC
//////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Registry.h"
#include "registerman.h"
#include "win_pdf2rtf.h"
#include "win_pdf2rtfDlg.h"
#include "OptionsDlg.h"
#include "DialogRegP2H.h"
#include "WriteDir.h"
#include "sbdestination.h"
#include "winsock.h"
#include <afxinet.h>
#include "parseargs.h"
#include <time.h>
#include <direct.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include "HyperLink.h"
#include "PropertySheetWithLogoDlg.h"
#include "CommandUsage.h"
#include "Html2pdf.h"
#include "LanguageDlg.h"
#include "GraphicsDlg.h"
#include <string>
using namespace std;
#include "ShellFileOp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern char szMailTo[];
extern char szEnglishHomepage[];
extern char szEnglishRegister[];

extern BOOL WINAPI ShowRegisterDlg(BOOL _IsRegistered,HWND hWnd);
extern INT  WINAPI CheckSerialNo();
extern BOOL	IsRegistered;

extern int PASCAL FAR WSAStartup(WORD wVersionRequired, LPWSADATA lpWSAData);
extern int PASCAL FAR connect (SOCKET s, const struct sockaddr FAR *name, int namelen);
extern unsigned long PASCAL FAR inet_addr (const char FAR * cp);
extern u_short PASCAL FAR htons (u_short hostshort);

extern HINSTANCE MyGotoURL(LPCTSTR url, int showcmd);
//δעûֻܴ5ҳPDFļ
#define UNREGISTER_MAX_PAGES	5

//в
int firstPage = 0;
int lastPage = 100000;
int zoomratio = -1;
BOOL printHelp = FALSE;
BOOL m_bAutoExit = FALSE;
BOOL m_bWithoutShowMainWnd = FALSE;
BOOL m_bOverwriteWithoutPrompt = FALSE;
vector<STEXT>	m_aryFont;
int  m_uCharSpaces = -1;

static char PDFFileName[260] = "";
static char HTMFileName[260] = "";
static ArgDesc argDesc[] = {
	{"-f",      argInt,      &firstPage,     0,			"First page to convert"},
	{"-l",      argInt,      &lastPage,      0,			"Last page to convert"},
	{"-z",      argInt,      &zoomratio,     -1,			"Zoom Ratio"},
	{"-b",	    argInt,	 &m_uCharSpaces, -1,			"Set space between characters"},
	{"-i",      argString,   PDFFileName,    sizeof(PDFFileName),	"PDF file will be convert"},
	{"-o",      argString,   HTMFileName,    sizeof(HTMFileName),	"RTF file will be generate"},
	{"-q",      argFlag,     &m_bAutoExit,   0,			"Exit after convert"},
	{"-m",      argFlag,     &m_bWithoutShowMainWnd,   0,		"Run without window"},
	{"-r",      argFlag,     &m_bOverwriteWithoutPrompt,   0,	"Overwrite an existing destination file without prompting to confirm"},
	{"-h",      argFlag,     &printHelp,     0,			"Print usage information"},
	{"-?",      argFlag,     &printHelp,     0,			"Print usage information"},
	{NULL}
};

static char szUsage[] = {
	"Usage: PDF2Word [Option] <PDF File> [<RTF File>]\r\n"
	"-f <page number> : First page to be converted\r\n"
	"-l <page number> : Last page to be converted\r\n"
	"-z <zoom ratio>  : Set zoom ratio when conversion, the range is from 50 to 200\r\n"
	"-b <space number>: Space between characters\r\n"
	"-q               : Exit after converting\r\n"
	"-m               : Run without window\r\n"
	"-r               : Overwrite an existing destination file without prompting to confirm\r\n"
	"-h or -?         : Print usage information\r\n"
	"-i <input PDF file name>   : PDF file will be converted\r\n"
	"-o <output RTF file name>  : RTF file will be generated\r\n"
	"\r\n"
	"For example      : \r\n"
	"	PDF2Word -i c:\\a.pdf\r\n"
	"	PDF2Word -i c:\\a.pdf -o c:\\a.rtf\r\n"
	"	PDF2Word -q -f 5 -l 8 -i c:\\a.pdf -o c:\\a.rtf\r\n"
	"	PDF2Word -q -f 1 -l 1 -i c:\\a.pdf -o c:\\a.rtf\r\n"
	"	PDF2Word -q -m -r -b 50 -f 1 -l 1 -i c:\\a.pdf -o c:\\a.rtf\r\n"
};
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

BOOL GetRtf(
		   SPage *pPage, 
		   const char * OutRTFName1,
		   char G_OR_B_Type,
		   HWND hMainWnd
		   )
{
	return TRUE;
}
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CHyperLink	m_HyperEmailLink;
	CHyperLink	m_HyperHomePageLink;
	CString	m_szRegisterInfo;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_szRegisterInfo = _T("");
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_STATIC_MAILTO, m_HyperEmailLink);
	DDX_Control(pDX, IDC_STATIC_HOMEPAGE, m_HyperHomePageLink);
	DDX_Text(pDX, IDC_EDIT_INFO, m_szRegisterInfo);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Cwin_pdf2rtfDlg dialog

Cwin_pdf2rtfDlg::Cwin_pdf2rtfDlg(CWnd* pParent /*=NULL*/)
	: CDialog(Cwin_pdf2rtfDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(Cwin_pdf2rtfDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void Cwin_pdf2rtfDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Cwin_pdf2rtfDlg)
	DDX_Control(pDX, IDC_STATIC_PDFVER, m_ctrlPDFVer);
	DDX_Control(pDX, IDC_PROGRESS_PAGE, m_wndPageProgress);
	DDX_Control(pDX, IDC_PROGRESS_FILES, m_wndFileProgress);
	DDX_Control(pDX, IDC_EXPLORER_PDFIMAGE, m_ctrlPDFImage);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(Cwin_pdf2rtfDlg, CDialog)
	//{{AFX_MSG_MAP(Cwin_pdf2rtfDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(IDM_FILE_PREFERENCES, OnFilePreferences)
	ON_COMMAND(IDM_FILE_OPEN, OnFileOpen)
	ON_UPDATE_COMMAND_UI(IDM_FILE_OPEN, OnUpdateFileOpen)
	ON_COMMAND(IDM_HELP_ABOUT, OnHelpAbout)
	ON_COMMAND(IDM_FILE_EXIT, OnFileExit)
	ON_COMMAND(IDM_HELP_SUPPORT, OnHelpSupport)
	ON_WM_DROPFILES()
	ON_COMMAND(IDM_FILE_TOP, OnFileTop)
	ON_UPDATE_COMMAND_UI(IDM_FILE_TOP, OnUpdateFileTop)
	ON_WM_MOUSEMOVE()
	ON_WM_DESTROY()
	ON_WM_CREATE()
	ON_WM_RBUTTONUP()
	ON_COMMAND(IDM_HELP_HELP, OnHelpHelp)
	ON_BN_CLICKED(IDPAUSE, OnPause)
	ON_BN_CLICKED(IDCLOSE, OnClose)
	ON_COMMAND(IDM_HELP_REGISTER, OnHelpRegister)
	ON_COMMAND(IDM_HELP_PRODUCTLIST, OnHelpProductlist)
	ON_COMMAND(IDM_HELP_BUYNOW, OnHelpBuynow)
	ON_COMMAND(IDM_HELP_PDF2HTM_ONWEB, OnHelpPdf2htmOnweb)
	ON_COMMAND(IDM_TOOLS_PDF2HTM, OnToolsPdf2htm)
	ON_COMMAND(IDM_TOOLS_PDF2BMP, OnToolsPdf2bmp)
	ON_WM_TIMER()
	ON_MESSAGE(WM_PROCESSING, OnRTFWriting)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
//
//ļм߳
//
/////////////////////////////////////////////////////////////////////////////
BOOL		g_bStrActive;
static DWORD	WINAPI NetBarListenThread(LPVOID  lpData)
{
	Cwin_pdf2rtfDlg* m_pMainDlg = (Cwin_pdf2rtfDlg*)lpData;
	CString m_strHtmlFile;
	while(g_bStrActive)
	{
		while(g_bStrActive && m_pMainDlg->m_aryPDF2HTMFile.GetSize() > 0)
		{
			BOOL m_bConversionOK = TRUE;
			//closeťıΪstop
			m_pMainDlg->GetDlgItem(IDCLOSE)->SetWindowText("Stop");
			//ʼȡеĵһ
			SCORECONVERT& m_coreConvert = m_pMainDlg->m_aryPDF2HTMFile[0];
			m_strHtmlFile=m_coreConvert.szHTMName;//ȡǰļ
			//жļǷ
			CFileFind FindHtm;
			UINT ReturnMsg;
			//ļѾ
			if (FindHtm.FindFile((LPCTSTR)m_coreConvert.szHTMName))
			{
				if(m_bOverwriteWithoutPrompt)
					ReturnMsg = IDYES;
				else
					ReturnMsg = AfxMessageBox(m_coreConvert.szHTMName+" existed,override? Select Cancel to skip the file.",MB_YESNOCANCEL);
				if (ReturnMsg == IDNO)//ûѡNoûѡļ
				{
					char sFilter[100];
					char szTitle[20];
					strcpy(szTitle,"rtf");strcpy(sFilter,"Word Files (*.rtf)|*.rtf|All Files (*.*)|*.*||");
					CFileDialog m_dlgFile(FALSE,szTitle,NULL,
					OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT|OFN_ALLOWMULTISELECT,sFilter,NULL);
					if(m_dlgFile.DoModal() == IDOK)
					{
						m_coreConvert.szHTMName=m_dlgFile.GetPathName();
						m_strHtmlFile=m_coreConvert.szHTMName;//ȡǰļ
					}
				}
				if (ReturnMsg != IDCANCEL)//ûѡcancelļ,ûѡȡתļ
				{
					m_bConversionOK = m_pMainDlg->ConvertPDF2HTML(m_coreConvert.szPDFName,m_coreConvert.szHTMName);
				}
			}
			else//ԭļֱת
			{
				m_bConversionOK = m_pMainDlg->ConvertPDF2HTML(m_coreConvert.szPDFName,m_coreConvert.szHTMName);
			}
			
			//ɾʹź־
			if(IsRegistered)
			{
				EnterCriticalSection(&m_pMainDlg->nCriticalSection);
				if(m_pMainDlg->m_aryPDF2HTMFile.GetSize() > 0)
					m_pMainDlg->m_aryPDF2HTMFile.RemoveAt(0);
				LeaveCriticalSection(&m_pMainDlg->nCriticalSection);
				//תԺʾʾϢ
				if(m_pMainDlg->m_aryPDF2HTMFile.GetSize() == 0)
				{
					if(m_bAutoExit)
						ExitProcess(0);
					else
						m_pMainDlg->MessageBox("Convert Finished!","PDF2Word software",MB_OK|MB_ICONEXCLAMATION|MB_APPLMODAL|MB_TOPMOST|MB_SYSTEMMODAL);
				}
			}
			else
			{//δע汾,̽ʣļȫ
				AfxMessageBox("Convert finished! Your softerware is not registered, you can only process one file and five pages in one time! The registered version hasn't these limitations.");
			
				EnterCriticalSection(&m_pMainDlg->nCriticalSection);
				m_pMainDlg->m_aryPDF2HTMFile.RemoveAll();
				LeaveCriticalSection(&m_pMainDlg->nCriticalSection);
			}
		
			if(m_pMainDlg->m_aryPDF2HTMFile.GetSize() == 0)
			{
				int m_bPreview = AfxGetApp()->GetProfileInt("Preview","Flag",0);
				if(m_bPreview && m_bConversionOK)
				{
					ShellExecute(NULL,"open",m_strHtmlFile,NULL,NULL,SW_SHOWNORMAL);
				}
			}
		}
		
		//ļΪգʾ
		if(m_pMainDlg->m_aryPDF2HTMFile.GetSize() == 0)
		{
			//closeťıΪClose
			m_pMainDlg->GetDlgItem(IDCLOSE)->SetWindowText("Close");
			m_pMainDlg->m_wndFileProgress.SetPos(0);
			m_pMainDlg->GetDlgItem(IDC_STATIC_FILENAME)->SetWindowText("");
			m_pMainDlg->GetDlgItem(IDC_STATIC_TOTALPAGES)->SetWindowText("");
			m_pMainDlg->GetDlgItem(IDC_STATIC_TOTALFILES)->SetWindowText("");
			m_pMainDlg->GetDlgItem(IDC_STATIC_FILESIZE)->SetWindowText("");
			m_pMainDlg->GetDlgItem(IDC_STATIC_VERSION)->SetWindowText("");
		}
		Sleep(100);
	}
	return 0;
}

void Cwin_pdf2rtfDlg::UpdateTitle()
{
	HMENU hMenu = ::GetMenu(m_hWnd);

	char szTitle[200];
	strcpy(szTitle,"PDF2Word v1.4");
	if(!IsRegistered)
		strcat(szTitle," (Trial version)");
	SetWindowText(szTitle);
}
//ʼԻ
BOOL Cwin_pdf2rtfDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	CHAR	szExeDir[MAX_PATH];
	GetModuleFileName(AfxGetInstanceHandle(),szExeDir,MAX_PATH);
	CHAR drive[_MAX_DRIVE],dir[_MAX_DIR],fname[_MAX_FNAME],ext[_MAX_EXT];
	_splitpath(szExeDir, drive, dir, fname, ext );
	_makepath(szExeDir, drive, dir,"pdf2html",".ani");
	hAniCursor = LoadCursorFromFile(szExeDir);
	DragAcceptFiles();

	m_wndPageProgress.SetRange(0,100);
	m_wndPageProgress.ShowPercent();
	m_wndFileProgress.SetRange(0,100);
	m_wndFileProgress.ShowPercent();

	int topmost = AfxGetApp()->GetProfileInt("WindowsTopMost","Flag",0);
	if(topmost)
	{
		::SetWindowPos( m_hWnd, HWND_TOPMOST, 0, 0, 0, 0,
				 SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
		UINT dwStyle = ::GetWindowLong(m_hWnd,GWL_EXSTYLE);
		HMENU hMenu = ::GetMenu(m_hWnd);
		CheckMenuItem(hMenu,IDM_FILE_TOP,(dwStyle&WS_EX_TOPMOST?MF_CHECKED:MF_UNCHECKED));
	}
	//ź
	InitializeCriticalSection(&nCriticalSection);
	//߳
	g_bStrActive = TRUE;
	DWORD dwThreadId;
	hNetBarThread = CreateThread(NULL,0,NetBarListenThread,this,0,&dwThreadId);
	if(hNetBarThread == NULL)
	{
		::MessageBox(NULL,"CreateThread error.","Error",MB_OK|MB_ICONSTOP);
		return FALSE;
	}

	cSpawn.Init(AfxGetInstanceHandle());
	cSpawn.SetBarImage(IDB_BMP_MENU,21);
	//cSpawn.SetBackBitmap(IDB_BMP_MENU);
	cSpawn.LoadToolBarResource(IMAGEVIEW_TOOLBARID);

	m_ctrlPDFVer
		.SetTextColor(RGB(255,255,0))
		.SetBkColor(RGB(0,0,0))
		.SetFontBold(TRUE)
		//.SetBorder(TRUE)
		.SetSunken(TRUE);

////////////////////////////////////////////////////////////////////////////
	{
		CHAR	szPDFImageUrl[MAX_PATH];
		GetModuleFileName(AfxGetInstanceHandle(),szPDFImageUrl,MAX_PATH);
		CHAR drive[_MAX_DRIVE],dir[_MAX_DIR],fname[_MAX_FNAME],ext[_MAX_EXT];
		_splitpath(szPDFImageUrl, drive, dir, fname, ext );
		_makepath(szPDFImageUrl, drive, dir,"","");
		if(szExeDir[strlen(szPDFImageUrl)-1] != '\\')
		strcat(szPDFImageUrl,"\\");

		strcat(szPDFImageUrl,"pdf2html.htm");
	
		
		COleVariant varEmpty;
		m_ctrlPDFImage.Navigate(szPDFImageUrl, &varEmpty, &varEmpty,&varEmpty, &varEmpty );
	}
///////////////////////////////////////////////////////////////////////////////////
	IsRegistered = TRUE;
	if(CheckSerialNo())
	{
		IsRegistered = FALSE;
		IsRegistered = ShowRegisterDlg(IsRegistered,m_hWnd);
	}
	HMENU hMenu = ::GetMenu(m_hWnd);
	if(IsRegistered)
		EnableMenuItem(hMenu,IDM_HELP_REGISTER,MF_GRAYED);

	UpdateTitle();

	// parse args
	int argc = __argc;
	char **argv = __argv;
	if(argc > 1)
	{
		GBool ok;
		ok = parseArgs(argDesc, &argc, argv);
		if (!ok || printHelp)
		{
			CCommandUsage dlg;
			dlg.m_szUsage = szUsage;
			dlg.DoModal();
			exit(1);
		}
		if(zoomratio >= 50 && zoomratio <= 200)
			AfxGetApp()->WriteProfileInt("ZoomRatio","Zoom",zoomratio);
		if(m_uCharSpaces >= 0 && m_uCharSpaces <= 200)
		{
			char szCurDir[_MAX_PATH];
			GetModuleFileName(NULL, szCurDir, _MAX_PATH);
			CString t = szCurDir;
			int pos = t.ReverseFind('\\');
			CString strInitFileName = t.Left(pos+1) + "config.ini";

			char buffer[50];
			sprintf(buffer,"%d",m_uCharSpaces);
			WritePrivateProfileString("PDF2Word","CharSpaces",buffer,strInitFileName);
		}
		if(firstPage != 0 || lastPage != 100000)
		{
			AfxGetApp()->WriteProfileInt("PageRangeType","Type",1);
			AfxGetApp()->WriteProfileInt("PageRange","From",firstPage);
			AfxGetApp()->WriteProfileInt("PageRange","To",lastPage);
		}
		else
			AfxGetApp()->WriteProfileInt("PageRangeType","Type",0);
		if(m_bWithoutShowMainWnd)
		{
			ShowWindow(SW_SHOWMINIMIZED);
		}
		if(PDFFileName[0])
		{
			char path_buffer[_MAX_PATH];
			char drive[_MAX_DRIVE];
			char dir[_MAX_DIR];
			char fname[_MAX_PATH];
			char ext[_MAX_EXT];

			SCORECONVERT m_coreConvert;
			m_coreConvert.szPDFName = PDFFileName;
			if(HTMFileName[0])
			{
				_splitpath(HTMFileName, drive, dir, fname, ext );
				_makepath(path_buffer,drive, dir,fname,".rtf");
				m_coreConvert.szHTMName = path_buffer;
			}
			else
			{
				_splitpath(PDFFileName, drive, dir, fname, ext );
				_makepath(path_buffer,drive, dir,fname,".rtf");
				m_coreConvert.szHTMName = path_buffer;
			}
			EnterCriticalSection(&nCriticalSection);
			m_aryPDF2HTMFile.Add(m_coreConvert);
			LeaveCriticalSection(&nCriticalSection);
		}
	}
	return TRUE;  // return TRUE  unless you set the focus to a control
}
void Cwin_pdf2rtfDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void Cwin_pdf2rtfDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR Cwin_pdf2rtfDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void Cwin_pdf2rtfDlg::OnFilePreferences() 
{
	CPropertySheetWithLogoDlg m_dlgOption("Preferences");
	m_dlgOption.SetLogoText("PDF2Word");
	m_dlgOption.m_psh.dwFlags &= ~PSH_HASHELP;
	m_dlgOption.m_psh.dwFlags |= PSH_NOAPPLYNOW;

	COptionsDlg	m_dlgFirstPage;
	m_dlgFirstPage.m_psp.dwFlags  &= ~PSP_HASHELP;
	m_dlgOption.AddPage(&m_dlgFirstPage);

	CHtml2pdf	m_dlgPDF2HTM;
	m_dlgPDF2HTM.m_psp.dwFlags  &= ~PSP_HASHELP;
	m_dlgOption.AddPage(&m_dlgPDF2HTM);

	CLanguageDlg	m_dlgLanguage;
	m_dlgLanguage.m_psp.dwFlags  &= ~PSP_HASHELP;
	m_dlgOption.AddPage(&m_dlgLanguage);

	CGraphicsDlg	m_dlgGraphics;
	m_dlgGraphics.m_psp.dwFlags  &= ~PSP_HASHELP;
	m_dlgOption.AddPage(&m_dlgGraphics);

	if(m_dlgOption.DoModal() == IDOK)
	{
		return;
	}
}


//////////////////////Ϸļ///////////////////////////////

void Cwin_pdf2rtfDlg::OnDropFiles(HDROP hDropInfo )
{
	char path_buffer[_MAX_PATH];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_PATH];
	char ext[_MAX_EXT];
	CHAR	FileName[MAX_PATH] ;
	int	NumOfFiles = 0 ;
	
	memset(FileName,0,MAX_PATH);
	NumOfFiles = DragQueryFile ((HDROP) hDropInfo, 0xffffffff, NULL, 0) ;

	for(INT i = 0; i < NumOfFiles; i++)//stop/close
	{
		DragQueryFile((HDROP) hDropInfo, i, FileName,MAX_PATH);
		//ӽļУʹź־
		EnterCriticalSection(&nCriticalSection);
		SCORECONVERT m_coreConvert;
		m_coreConvert.szPDFName = FileName;

		_splitpath(FileName, drive, dir, fname, ext );
		_makepath(path_buffer,drive, dir,fname,".rtf");

		m_coreConvert.szHTMName = path_buffer;
		m_aryPDF2HTMFile.Add(m_coreConvert);
		LeaveCriticalSection(&nCriticalSection);
	}
	DragFinish ((HDROP) hDropInfo) ;

}


/////////////////////////////////////////////////////////////////////
////////////////////////////////////////ļ//////////////////////
void Cwin_pdf2rtfDlg::OnFileOpen() 
{
	char path_buffer[_MAX_PATH];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_PATH];
	char ext[_MAX_EXT];
	char *m_pChBuf = NULL;
	char sFilterPDF[] = "PDF Files (*.PDF)|*.pdf|All Files (*.*)|*.*||";

	char sFilter[100];
	char szTitle[20];
	strcpy(szTitle,"rtf");strcpy(sFilter,"Word Files (*.rtf)|*.rtf|All Files (*.*)|*.*||");
	if ( ( m_pChBuf	= ( char * ) malloc( 1024*100 )) == NULL )
		return;
	memset(m_pChBuf,0,1024*100);

	CFileDialog DlgFile(TRUE,"PDF","",
	OFN_FILEMUSTEXIST|OFN_HIDEREADONLY|OFN_ALLOWMULTISELECT,sFilterPDF,NULL);
	DlgFile.m_ofn.lpstrTitle = "Open PDF Files";
	DlgFile.m_ofn.lpstrFile = m_pChBuf;
	DlgFile.m_ofn.nMaxFile = 20000;
	DlgFile.m_ofn.nFilterIndex = 0;
	DlgFile.m_ofn.lpstrInitialDir = AfxGetApp()->GetProfileString("FilePath","LastOpenPath","C:\\");

	CString m_szFileName;

	if ( DlgFile.DoModal() == IDOK)
	{
		//
		//ѡ񵥸ļҪûṩΪļƣǶ
		//ļֱ
		//
		char* pChBuf = m_pChBuf;
		pChBuf += strlen( pChBuf ) + 1;
		if ( *pChBuf == 0 )		//only one file
		{
			_splitpath(m_pChBuf, drive, dir, fname, ext );
			_makepath(path_buffer,drive, dir,"","");
			AfxGetApp()->WriteProfileString("FilePath","LastOpenPath",path_buffer);

			CFileDialog m_dlgFile(FALSE,szTitle,fname,
				OFN_HIDEREADONLY|OFN_ALLOWMULTISELECT,sFilter,NULL);
			if(m_dlgFile.DoModal() == IDOK)
			{
				CString strHtmlFileName = m_dlgFile.GetPathName();
				//ӽļУʹź־
				EnterCriticalSection(&nCriticalSection);
				SCORECONVERT m_coreConvert;
				m_coreConvert.szPDFName = m_pChBuf;

				_splitpath(strHtmlFileName, drive, dir, fname, ext );
				_makepath(path_buffer,drive, dir,fname,".rtf");
				m_coreConvert.szHTMName = path_buffer;				

				m_aryPDF2HTMFile.Add(m_coreConvert);
				LeaveCriticalSection(&nCriticalSection);
			}
			free(m_pChBuf);
			return;
		}
		//
		CSBDestination sb(m_hWnd,IDS_BROWDIRTITLE_E);
		sb.SetFlags(BIF_RETURNONLYFSDIRS | BIF_STATUSTEXT);
		CString pathstr = AfxGetApp()->GetProfileString("htmSaveDefaultDirectory","Path","");
		sb.SetInitialSelection(pathstr);
		CString strSaveHtmDirectory;
		if (sb.SelectFolder())
		{
			strSaveHtmDirectory = sb.GetSelectedFolder();
			AfxGetApp()->WriteProfileString("htmSaveDefaultDirectory","Path",strSaveHtmDirectory);
		}
		else
			return;
		AfxGetApp()->WriteProfileString("FilePath","LastOpenPath",m_pChBuf);
		//ӽļУʹź־
		EnterCriticalSection(&nCriticalSection);
		POSITION pos = DlgFile.GetStartPosition();
		while(pos)
		{
			m_szFileName = DlgFile.GetNextPathName(pos);
			_splitpath(m_szFileName, drive, dir, fname, ext );

			CString strHtmlFileName = strSaveHtmDirectory;
			if(strHtmlFileName[strHtmlFileName.GetLength()-1] != '\\')
				strHtmlFileName += "\\";
			strHtmlFileName += fname;
			strHtmlFileName += ".";
			strHtmlFileName += szTitle;

			SCORECONVERT m_coreConvert;
			m_coreConvert.szPDFName = m_szFileName;

			_splitpath(strHtmlFileName, drive, dir, fname, ext );
			_makepath(path_buffer,drive, dir,fname,".rtf");
		
			m_coreConvert.szHTMName = path_buffer;
			m_aryPDF2HTMFile.Add(m_coreConvert);
		}
		LeaveCriticalSection(&nCriticalSection);
	}
	free(m_pChBuf);
}

void Cwin_pdf2rtfDlg::OnUpdateFileOpen(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

void Cwin_pdf2rtfDlg::OnHelpAbout() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}

void Cwin_pdf2rtfDlg::OnFileExit() 
{
	OnCancel();
}

//Close buttom
void Cwin_pdf2rtfDlg::OnCancel() 
{
	if(MessageBox("Do you want exit?","PDF2Word",MB_YESNO) == IDYES)
		ExitProcess(0);
}
void Cwin_pdf2rtfDlg::OnHelpSupport() 
{
	ShellExecute(NULL,"open",szMailTo,NULL,NULL,SW_SHOWNORMAL);
}
BOOL Cwin_pdf2rtfDlg::ConvertPDF2HTML(CString m_strPDFFile, CString m_strHtmlFile)
{
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char FileName[_MAX_PATH];
	char ext[_MAX_EXT];
	_splitpath(m_strPDFFile, drive, dir, FileName, ext );

	CString m_strHtmlFileStore = m_strHtmlFile;
	CString	m_strPDFName;
	CString	m_strVersion;
	CString	m_strFileSize;
	CString	m_strTotalPageInfo;
	CString	m_strTotalFiles;
	m_strPDFName = _T("");
	m_strVersion = _T("");
	m_strFileSize = _T("");
	m_strTotalPageInfo = _T("");
	m_strTotalFiles = _T("");

	//=====ȡļϢ================================================
	HANDLE  FileHwnd;
	HRESULT  Hresult;
	WIN32_FIND_DATA FileInfo; 
	FileHwnd = FindFirstFile((LPCTSTR)m_strPDFFile, &FileInfo);
	Hresult = FindClose(FileHwnd);              
	//=================================================================
	m_strPDFName = m_strPDFFile;
	m_strVersion = _T("");
	m_strFileSize = _T("");
	GetDlgItem(IDC_STATIC_FILENAME)->SetWindowText(m_strPDFName);

	struct _stat buf;
	if(_stat(m_strPDFName, &buf ) == 0)
	{
		if(buf.st_size/1024 < 1024)
		{//KB
			m_strFileSize.Format("%d<%.2fK>",buf.st_size,buf.st_size/1024.0);
		}
		else
			m_strFileSize.Format("%d<%.2fM>",buf.st_size,buf.st_size/1024.0/1024.0);
	}
	GetDlgItem(IDC_STATIC_FILESIZE)->SetWindowText(m_strFileSize);

	//ϵ
	int m_iZoomRatio = AfxGetApp()->GetProfileInt("ZoomRatio","Zoom",100);
	int m_iPageFrom = 1,m_iPageTo = 100000;
	int m_iPageRange = AfxGetApp()->GetProfileInt("PageRangeType","Type",0);
	if(m_iPageRange == 1)
	{//ָ˿ʼҳͽҳ
		m_iPageFrom = AfxGetApp()->GetProfileInt("PageRange","From",1);
		m_iPageTo = AfxGetApp()->GetProfileInt("PageRange","To",100000);
		if(m_iPageFrom > m_iPageTo || m_iPageFrom < 0 || m_iPageTo < 0)
		{
			if(!m_bWithoutShowMainWnd)
				AfxMessageBox("Page range is incorrect,Please check it in option dialog,and try again.");
			return FALSE;
		}
	}

	float scaleRatio = m_iZoomRatio/29.0;
	m_iZoomRatio = 72.0;
	HPDF	m_hPDF = PDF_Open(LPCTSTR(m_strPDFFile),NULL,NULL,m_iZoomRatio);
	if(m_hPDF)
	{
		//ǰPDFҳ
		int m_PageCount= PDF_GetPageCount(m_hPDF);
		if(m_iPageRange == 1)
		{//ָ˿ʼҳͽҳ
			m_iPageFrom = max(1,m_iPageFrom);
			m_iPageTo = min(m_PageCount,m_iPageTo);
		}
		else
		{//all pages
			m_iPageFrom = 1;
			m_iPageTo = m_PageCount;
		}
		if(!IsRegistered)
			m_iPageTo = min(m_iPageTo,UNREGISTER_MAX_PAGES);
		if(m_iPageFrom > m_iPageTo)
		{
			CString strErrMessage;
			strErrMessage.Format("The '%s' file only contain %d pages, please correct the page range in the setting dialog and try again.",LPCTSTR(m_strPDFFile),m_PageCount);
			if(!m_bWithoutShowMainWnd)
				AfxMessageBox(strErrMessage);
			return FALSE;
		}

		//ҳжϱ־
		m_bTerminateProcessPage = FALSE;

		m_aryFont.clear();

		SPage  MySPage;
		SPage* ptrSPage = &MySPage;
		int TotalPage = m_iPageTo-m_iPageFrom+1;

		for(int page = m_iPageFrom;  !m_bTerminateProcessPage && g_bStrActive && page <= m_iPageTo; page++)
		{
			//淴Ӧ------------------------------------
			//ļ
			int totalFiles = m_aryPDF2HTMFile.GetSize();
			m_strTotalFiles.Format("%d files",totalFiles);
			GetDlgItem(IDC_STATIC_TOTALFILES)->SetWindowText(m_strTotalFiles);
			m_wndFileProgress.SetPos(99/totalFiles);
			//ҳ
			//m_strTotalPageInfo.Format("page %d of %d",page,m_PageCount);
			m_strTotalPageInfo.Format("page %d of %d",page-m_iPageFrom+1,(m_iPageTo-m_iPageFrom+1));
			GetDlgItem(IDC_STATIC_TOTALPAGES)->SetWindowText(m_strTotalPageInfo);
			//m_wndPageProgress.SetPos((page*100-1)/m_PageCount);
			m_wndPageProgress.SetPos(((page-m_iPageFrom+1)*100-1)/(m_iPageTo-m_iPageFrom+1));
			//Ĵ-------------------------------------------
			{
				LPSPAGE	ptrPage = PDF_GetPageObject(m_hPDF,page);
				if(ptrPage)
				{
					m_strVersion.Format("%%PDF-%.1f",ptrPage->m_PDFVersion);
					GetDlgItem(IDC_STATIC_VERSION)->SetWindowText(m_strVersion);
				}
				if(!m_bTerminateProcessPage && g_bStrActive && ptrPage)
				{
					ConvertPdfPage2HTML(ptrSPage,m_iPageFrom,ptrPage,m_strHtmlFile,scaleRatio);
					//PDF_WriteToTXTFile(m_hPDF,page,"F:\\text.txt");
				}
				if(ptrPage)
					PDF_DestroyPageObject(ptrPage);
				ptrPage = NULL;
			}
			//next page
			if(page < m_iPageTo)
			{
				ptrSPage->NextPage = new SPage;
				ptrSPage = ptrSPage->NextPage;
			}
		}
		PDF_Close(m_hPDF);
		if(GetRtf(&MySPage,m_strHtmlFile,'G',m_hWnd))
		{
		}
	}
	else
	{
		if(!m_bWithoutShowMainWnd)
		{
			CString strErrMessage;
			strErrMessage.Format("Can't extract the information from the '%s' file, "
				"this pdf file perhaps been encrypted, please double check this pdf file.",
				LPCTSTR(m_strPDFFile));
			AfxMessageBox(strErrMessage);
		}
	}
	m_wndPageProgress.SetPos(0);
	return TRUE;
}
void checkItem(SBlock*  pBlock)
{
#ifdef _DEBUG
	if(pBlock->nBlockType != PAGE_NULL)
	{
		MessageBox(NULL,"This Item have contents.",NULL,MB_OK);
	}
#endif
}
SBlock* OutputTextToRTFFiile(SBlock*  pBlock, LPSPAGE ptrPage,float scaleRatio)
{
	STEXT m_LastCodes;
	memset(&m_LastCodes,0,sizeof(STEXT));
	char szCurDir[_MAX_PATH];
	GetModuleFileName(NULL, szCurDir, _MAX_PATH);
	CString t = szCurDir;
	int pos = t.ReverseFind('\\');
	CString strInitFileName = t.Left(pos+1) + "config.ini";
	int  m_uCharDistance = GetPrivateProfileInt("PDF2Word","CharSpaces",100,strInitFileName);
	BOOL m_bUseTextBox = AfxGetApp()->GetProfileInt("m_bUseTextBox","Flag",1);
	BOOL m_bAutoSpace = AfxGetApp()->GetProfileInt("m_bAutoSpace","Flag",TRUE);
	int m_idxLanguage = AfxGetApp()->GetProfileInt("CLanguageDlg","m_idxLanguage",0);
	BOOL m_bMergeRows = AfxGetApp()->GetProfileInt("CHtml2pdf","m_bMergeRows",TRUE);
	if(!m_bUseTextBox)
		m_bMergeRows = FALSE;
	BOOL m_bDeleteLineBreaks = AfxGetApp()->GetProfileInt("CHtml2pdf","m_bDeleteLineBreaks",FALSE);
	if(!m_bMergeRows)
		m_bDeleteLineBreaks = FALSE;

	vector<STEXT>	m_aryFont;
	int nsize = ptrPage->m_pageBlock.size();
	for(int i = 0; i < nsize; i++)
	{
		if(ptrPage->m_pageBlock[i]->m_type == PDF_TEXT)
		{
			STEXT &m_Codes = *ptrPage->m_pageBlock[i]->m_Codes;
			if(m_Codes.m_dAngle != 0)
				continue;

			BOOL	bFound = FALSE;
			for(int iii = 0; iii < m_aryFont.size(); iii++)
			{
				//СȷΨһ
				if(m_aryFont[iii].nFontWidth == m_Codes.nFontWidth
					&& m_aryFont[iii].szFontName == m_Codes.szFontName
					&& m_aryFont[iii].color == m_Codes.color
					&& m_aryFont[iii].m_bIsItalic == m_Codes.m_bIsItalic
					&& m_aryFont[iii].m_bIsBold == m_Codes.m_bIsBold
					)
				{
					bFound = TRUE;
					break;
				}
			}
			if(!bFound)
				m_aryFont.push_back(m_Codes);
		}
	}
	vector<STEXT>	m_aryTextBlock;
	for(i = 0; i < nsize; i++)
	{
		string	m_aryText;
		int	m_firstX = 0;
		int	m_firstY = 0;
		int	m_aryWidth = 0;
		int	m_aryHeight = 0;
		BOOL	m_bBold	= FALSE;
		BOOL	m_bItalic = FALSE;
		COLORREF m_clColor = 0;
		if(ptrPage->m_pageBlock[i]->m_type == PDF_TEXT)
		{
			STEXT &m_Codes = *ptrPage->m_pageBlock[i]->m_Codes;
			if(m_Codes.m_dAngle != 0)
				continue;

			int m_iFound = -1;
			for(int iii = 0; iii < m_aryFont.size(); iii++)
			{
				//СȷΨһ
				if(m_aryFont[iii].nFontWidth == m_Codes.nFontWidth
					&& m_aryFont[iii].szFontName == m_Codes.szFontName
					&& m_aryFont[iii].color == m_Codes.color
					&& m_aryFont[iii].m_bIsBold == m_Codes.m_bIsBold
					&& m_aryFont[iii].m_bIsItalic == m_Codes.m_bIsItalic
					)
				{
					m_iFound = iii;
					break;
				}
			}
			if(m_iFound == -1)
				continue;
			m_firstX = m_Codes.x;
			m_firstY = m_Codes.y;
			m_bBold = m_Codes.m_bIsBold;
			m_bItalic = m_Codes.m_bIsItalic;
			m_clColor = m_Codes.color;
			BOOL writecharflag = TRUE;
			do
			{
				char buf[16];
				memset(buf,0,16);
				if(writecharflag)
				{
					if(m_Codes.x == m_LastCodes.x && m_Codes.y == m_LastCodes.y
						&& m_Codes.szCode == m_LastCodes.szCode)
					{
					}
					else
					{
						float space = m_LastCodes.nFontHeight;
						float ddd = m_Codes.x - (m_LastCodes.x+m_LastCodes.nFontWidth);
						int addSpace = (space == 0?0:ddd>0.15*space);
						m_LastCodes = m_Codes;
						int destCount = WideCharToMultiByte(CP_ACP,0,
							(const unsigned short *)m_Codes.szCode.c_str(),
							m_Codes.nCount,buf,16,
							NULL,NULL
							);
						if(buf[0] == '?' && m_Codes.szCode[0] != '?')
							//buf[0] = '.';
							buf[0] = ' ';
						else
						{
							WORD dwCode = MAKEWORD(buf[1],buf[0]);
							switch(dwCode)
							{
							case 0xA1AE:
							case 0xA1AF:
								buf[0] = '\'';
								buf[1] = 0;
								break;
							case 0xA1B0:
							case 0xA1B1:
								buf[0] = '"';
								buf[1] = 0;
								break;
							}
							if(m_idxLanguage == 1)
							{//pure English Document
								if((unsigned char)(buf[0]) >= 0x80)
								{
									buf[0] = ' ';
									buf[1] = 0;
								}
							}
						}
						//TRACE("(%d,%d,%d,%d),%s\n",m_Codes.x,m_Codes.y,m_Codes.nFontWidth,m_Codes.nFontHeight,buf);
						if(m_bAutoSpace && addSpace)
							m_aryText += " ";
						m_aryText	+= buf;
						m_aryWidth	+= m_Codes.nFontWidth;
						if(0)
						{
							if(m_Codes.nFontHeight > m_aryHeight)
								m_aryHeight = m_Codes.nFontHeight;
						}
						else
						{
							if(m_aryHeight == 0)
								m_aryHeight = m_Codes.nFontHeight;
							else
								m_aryHeight = (m_aryHeight+m_Codes.nFontHeight)/2;
						}
					}
				}
				if(m_uCharDistance == 0)
					break;
				int nextIndex = i+1;
				while(nextIndex < nsize && ptrPage->m_pageBlock[nextIndex]->m_type != PDF_TEXT)
				{
					nextIndex++;
				}
				if(nextIndex < nsize && ptrPage->m_pageBlock[nextIndex]->m_type == PDF_TEXT)
				{
					i = nextIndex;
					STEXT &m_Codes1 = *ptrPage->m_pageBlock[i]->m_Codes;
					if(m_Codes1.m_dAngle != 0)
					{
						i--;
						break;
					}
					int distance = m_Codes1.x-m_Codes.x;//-m_Codes.nFontWidth;
					if(distance <= 0 || distance > m_uCharDistance)
					{//ı黻лı̫ʱ
						if(!m_bMergeRows)
						{//ı黻УҲϲı飬Ϊλ
							i--;
							break;
						}
						if(distance > m_uCharDistance)
						{//ı֮ϴ
							i--;
							break;
						}
					}
					int yy1 = m_Codes1.y-m_Codes1.nFontHeight+2;
					int yy  = m_Codes.y-m_Codes.nFontHeight+2;
					if(
					//	m_Codes1.nFontWidth == m_Codes.nFontWidth
					//	&& m_Codes1.szFontName == m_Codes.szFontName
					//	&& m_Codes1.color == m_Codes.color
						abs(yy1-yy) < max(m_Codes1.nFontHeight,m_Codes.nFontHeight)
						&& m_Codes1.x > m_Codes.x
						)
					{
						WORD nCode1 = *(LPWORD)&m_Codes1.szCode[0];
						WORD nCode  = *(LPWORD)&m_Codes.szCode[0];
						m_Codes = m_Codes1;
						writecharflag = TRUE;
					}
					else
					{
						BOOL m_bSameAttrib = 
							m_Codes1.szFontName == m_Codes.szFontName
							&& m_Codes1.color == m_Codes.color
							&& m_Codes1.m_bIsBold == m_Codes.m_bIsBold
							&& m_Codes1.m_bIsItalic == m_Codes.m_bIsItalic
							&& m_Codes1.nFontHeight == m_Codes.nFontHeight;
						if(m_bMergeRows && m_bSameAttrib && yy+m_Codes.nFontHeight*2 > yy1
							&& m_firstX == m_Codes1.x)
						{//оСıеĸ߶ȣϲı
							if(m_bDeleteLineBreaks)
								m_aryText += " ";
							else
								m_aryText += "\n";
							m_aryHeight += m_Codes.nFontHeight;
							WORD nCode1 = *(LPWORD)&m_Codes1.szCode[0];
							WORD nCode  = *(LPWORD)&m_Codes.szCode[0];
							m_Codes = m_Codes1;
							writecharflag = TRUE;
						}
						else
						{
							i--;
							break;
						}
					}
				}
				else
					break;
			}while(1);

			int m_intTextLen = m_aryText.size();
			if(m_intTextLen > 0)
			{
				STEXT m_nText;
				m_nText.x = (m_firstX+m_aryHeight/3)*scaleRatio;
				m_nText.y = (m_firstY-m_aryHeight*1.5)*scaleRatio;
				m_nText.color = m_clColor;
				m_nText.nFontWidth = (m_aryWidth+10)*scaleRatio;
				m_nText.nFontHeight = (m_aryHeight)*scaleRatio;
#if 1
				m_nText.m_iFontIndex = _TIMES_NEW_ROMAN_;
				//for(int iii = 0; iii < m_intTextLen; iii++)
				//{
				//	char m_nChar = m_aryText[iii];
				//	if((unsigned char)m_nChar >= 0x80)
				//		m_aryText[iii] = 0x20;
				//}
#else
				//Chinese font
				m_nText.m_iFontIndex = _SONG_TI_;
#endif
				m_nText.m_bIsBold = m_bBold;
				m_nText.m_bIsItalic = m_bItalic;
				m_nText.m_iSize = (m_aryHeight)*scaleRatio;
				m_nText.szCode = m_aryText;

				BOOL m_bMerged = FALSE;
				int m_nArySize = m_aryTextBlock.size();
				if(!m_bUseTextBox)
				{//ϲͬһеı
					for(int textIndex = 0; textIndex < m_nArySize; textIndex++)
					{
						STEXT &m_nText1 = m_aryTextBlock[textIndex];
						if(m_nText.y == m_nText1.y)
						{
							int m_iCharSpace = m_nText.x - m_nText1.x;
							if(m_iCharSpace <= 0)
								m_nText1.szCode += " ";
							else
							{
								m_iCharSpace /= 15;
								if(m_iCharSpace <= 0)
									m_iCharSpace = 1;
								//for(int _i = 0; _i < m_iCharSpace; _i++)
									m_nText1.szCode += " ";
							}
							m_nText1.szCode += m_nText.szCode;
							m_bMerged = TRUE;
							break;
						}
					}
				}
				if(!m_bMerged)
				{//ûСϲ
					for(int textIndex = 0; textIndex < m_nArySize; textIndex++)
					{
						STEXT &m_nText1 = m_aryTextBlock[textIndex];
						if(m_nText.y < m_nText1.y)
						{
							m_aryTextBlock.insert(m_aryTextBlock.begin()+textIndex,m_nText);
							m_bMerged = TRUE;
							break;
						}
					}
					if(!m_bMerged)
						m_aryTextBlock.push_back(m_nText);
				}

			}
		}
	}

	int m_iLastRowPos = 0;
	int m_nArySize = m_aryTextBlock.size();
	for(i = 0; i < m_nArySize; i++,pBlock++)
	{
		STEXT &m_nText = m_aryTextBlock[i];
		int m_intTextLen = m_nText.szCode.size();
		if(m_intTextLen <= 0)
			continue;
		checkItem(pBlock);
		pBlock->nBlockType = PAGE_TEXT;
		pBlock->pBlockEntity.pText = new SText;
		SText* pText = pBlock->pBlockEntity.pText;
		
		pText->nPosX = m_nText.x;
		pText->nPosY = m_nText.y;
		pText->nColor = m_nText.color;
		if(pText->nColor == RGB(255,255,255))
			pText->nColor = RGB(0,0,0);
		pText->nWidth = m_nText.nFontWidth;
		pText->nHeight = m_nText.nFontHeight;
		pText->nFont = m_nText.m_iFontIndex;
		if(m_nText.m_bIsBold)
			pText->nStyle |= TXT_BOLD;
		if(m_nText.m_bIsItalic)
			pText->nStyle |= TXT_ITALIC;
		if(m_bUseTextBox)
			pText->nStyle |= TXT_USEBOX;
		pText->nSize = m_nText.m_iSize;
		
		int m_iRowSpace = 0;
		if(!m_bUseTextBox)
		{
			if(m_iLastRowPos > 0 && m_nText.nFontHeight > 0)
			{
				m_iRowSpace = m_nText.y - m_iLastRowPos;
				m_iRowSpace = m_iRowSpace/(m_nText.nFontHeight+m_nText.nFontHeight/3);
				if(m_iRowSpace < 0)
					m_iRowSpace = 0;
			}
		}
		m_intTextLen += m_iRowSpace;
		pText->csContent = new char[m_intTextLen+1];
		memset(pText->csContent,0,m_intTextLen+1);
		if(m_iRowSpace)
			memset(pText->csContent,'\n',m_iRowSpace);
		strcpy(pText->csContent+m_iRowSpace,m_nText.szCode.c_str());
		pText->csContentLen = strlen(pText->csContent);

		m_iLastRowPos = pText->nPosY+pText->nHeight;
	}
	return pBlock;
}
SBlock* OutputImageToRTFFile(SBlock*  pBlock, LPSPAGE ptrPage,float scaleRatio)
{
	int nsize = ptrPage->m_pageBlock.size();
	for(int i = 0; i < nsize; i++)
	{
		if(ptrPage->m_pageBlock[i]->m_type == PDF_IMAGE)
		{
			SIMAGE	&m_Images = *ptrPage->m_pageBlock[i]->m_Images;

			checkItem(pBlock);
			pBlock->nBlockType = PAGE_BMP;
			pBlock->pBlockEntity.pBitmap = new SPicture;
			SPicture* pBmp = pBlock->pBlockEntity.pBitmap;
			
			pBmp->nPosX	= m_Images.x  * scaleRatio;
			pBmp->nPosY	= m_Images.y  * scaleRatio;
			pBmp->nWidth	= m_Images.cx * scaleRatio;
			pBmp->nHeight	= m_Images.cy * scaleRatio;

			pBmp->nStyle	= 3;
			
			pBmp->nLen	= sizeof(BITMAPINFOHEADER)+m_Images.pData.size();
			pBmp->pData = new BYTE[pBmp->nLen];
			memcpy(pBmp->pData,&m_Images.nBitmapInfo.bmiHeader,sizeof(BITMAPINFOHEADER));
			memcpy(pBmp->pData+sizeof(BITMAPINFOHEADER),m_Images.pData.begin(),m_Images.pData.size());

			pBlock++;
		}
	}
	return pBlock;
}
SBlock* OutputLineToRTFFile(SBlock*  pBlock, LPSPAGE ptrPage,float scaleRatio)
{
	int nsize = ptrPage->m_pageBlock.size();
	for(int i = 0; i < nsize; i++)
	{
		if(ptrPage->m_pageBlock[i]->m_type == PDF_LINE)
		{
			SLINE	&m_Lines = *ptrPage->m_pageBlock[i]->m_Lines;
			if(m_Lines.x0 <= 0 || m_Lines.x1 >= ptrPage->m_Width
				|| m_Lines.y0 <= 0 || m_Lines.y1 >= ptrPage->m_Height)
			{
				continue;
			}
			if(m_Lines.x0 >= ptrPage->m_Width || m_Lines.y0 >= ptrPage->m_Height)
			{
				continue;
			}
			checkItem(pBlock);
			pBlock->nBlockType = PAGE_LINE;
			pBlock->pBlockEntity.pLine = new SLine;
			SLine* pLine = pBlock->pBlockEntity.pLine;
			
			pLine->nStartX = (m_Lines.x0) * scaleRatio;
			pLine->nStartY = (m_Lines.y0) * scaleRatio;
			pLine->nWidthX = (m_Lines.x1-m_Lines.x0) * scaleRatio;
			pLine->nWidthY = (m_Lines.y1-m_Lines.y0) * scaleRatio;
			pLine->nLineWidth = m_Lines.width * scaleRatio;
			pLine->nColor = m_Lines.color;
			pLine->nStyle = m_Lines.style;
			pBlock++;
		}
	}
	return pBlock;
}
void DrawObjects(SPage* ptrSPage,LPSPAGE ptrPage,float scaleRatio)
{
	BOOL m_bDeleteGraphics = AfxGetApp()->GetProfileInt("CGraphicsDlg","m_bDeleteGraphics",0);
	BOOL m_bDeletePictures = AfxGetApp()->GetProfileInt("CGraphicsDlg","m_bDeletePictures",0);
	if(ptrPage)
	{
		BOOL m_bUseTextBox = AfxGetApp()->GetProfileInt("m_bUseTextBox","Flag",1);
		int nsize = ptrPage->m_pageBlock.size();
		ptrSPage->nBlockNum = nsize;//
		ptrSPage->nWidth = ptrPage->m_Width*scaleRatio;
		ptrSPage->nHeight = ptrPage->m_Height*scaleRatio;
		if(!m_bUseTextBox)
			ptrSPage->nHeight = ptrSPage->nHeight*1.2;
		ptrSPage->pBlock = new SBlock[ptrSPage->nBlockNum];
		SBlock*  pBlock = ptrSPage->pBlock;
		if(!m_bDeletePictures)
			pBlock = OutputImageToRTFFile(pBlock,ptrPage,scaleRatio);
		if(!m_bDeleteGraphics)
			pBlock = OutputLineToRTFFile(pBlock,ptrPage,scaleRatio);
		pBlock = OutputTextToRTFFiile(pBlock,ptrPage,scaleRatio);
	}
}

void Cwin_pdf2rtfDlg::ConvertPdfPage2HTML(SPage* ptrSPage,int firstpage,LPSPAGE ptrPage, 
					  CString m_strHtmlFileName,float scaleRatio)
{
	DrawObjects(ptrSPage,ptrPage,scaleRatio);
}

typedef BOOL (WINAPI * OCRFUNC)(LPSTR,char*,int,int,char,char);
int OCRForImage(CString m_strBMPFile,CString m_strTempFileStore)
{
	return TRUE;
}

void Cwin_pdf2rtfDlg::OnFileTop() 
{
	DWORD dwStyle = GetWindowLong (m_hWnd,GWL_EXSTYLE);
	if(dwStyle & WS_EX_TOPMOST)
		::SetWindowPos( m_hWnd, HWND_NOTOPMOST, 0, 0, 0, 0,
			       SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
	else
		::SetWindowPos( m_hWnd, HWND_TOPMOST, 0, 0, 0, 0,
				 SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);
	dwStyle = ::GetWindowLong(m_hWnd,GWL_EXSTYLE);
	HMENU hMenu = ::GetMenu(m_hWnd);
	CheckMenuItem(hMenu,IDM_FILE_TOP,(dwStyle&WS_EX_TOPMOST?MF_CHECKED:MF_UNCHECKED));
	AfxGetApp()->WriteProfileInt("WindowsTopMost","Flag",dwStyle&WS_EX_TOPMOST?1:0);
}

void Cwin_pdf2rtfDlg::OnUpdateFileTop(CCmdUI* pCmdUI) 
{
}
void Cwin_pdf2rtfDlg::ExportRSC(CString PathName,char *RID,char *RSCDIR,CString FileName)
{
}
void Cwin_pdf2rtfDlg::WriteMainHtm(CString CssPathName,CString MainHtmName,int firstpage, int lastpage)
{
}
void Cwin_pdf2rtfDlg::WriteIndexHtm(CString CssPathName,CString MainHtmName,int firstpage,int lastpage)
{
}
void Cwin_pdf2rtfDlg::WriteBmarkHtm(HPDF m_hPDF,CString CssPathName,CString MainHtmName,int firstpage,int lastpage)
{
}
void Cwin_pdf2rtfDlg::WriteNavHtm(CString CssPathName,CString MainHtmName,int firstpage,int lastpage)
{
}

void Cwin_pdf2rtfDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	if(m_aryPDF2HTMFile.GetSize() > 0)
	{
		CString m_strPause;
		GetDlgItem(IDPAUSE)->GetWindowText(m_strPause);
		if(m_strPause == "Pause")//ǰͣ״̬
			SetCursor(hAniCursor);
	}
	//CDialog::OnMouseMove(nFlags, point);
}
void Cwin_pdf2rtfDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	g_bStrActive = FALSE;
	if(hNetBarThread)
	{
		if(WaitForSingleObject(hNetBarThread,5000) == WAIT_TIMEOUT)
		{
			TerminateThread(hNetBarThread,0);
		}
		CloseHandle(hNetBarThread);
		hNetBarThread = NULL;
	}
	//ɾź
	DeleteCriticalSection(&nCriticalSection);
}

int Cwin_pdf2rtfDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	SetTimer(100,5,NULL);
	
	return 0;
}

BOOL Cwin_pdf2rtfDlg::PreTranslateMessage(MSG* pMsg) 
{
	switch(pMsg->message)
	{
	case WM_KEYDOWN:
	case WM_CHAR:
	case WM_SYSCHAR:
	case WM_SYSKEYDOWN:
		{
			if(MyCheckKeyDown(pMsg->hwnd,pMsg->wParam,pMsg->lParam))
				return TRUE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}

LRESULT Cwin_pdf2rtfDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	if(MenuPreTranslateMessage(cSpawn,m_hWnd,
		message,wParam,lParam) == TRUE)
		return 1;
	
	return CDialog::WindowProc(message, wParam, lParam);
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_HyperEmailLink.SetURL(szMailTo);
	m_HyperEmailLink.SetUnderline(FALSE);
	
	CString szHomePage;
	if(strstr(szEnglishHomepage,"www.verypdf.com") == NULL)
		szHomePage = "Affiliate: ";
	szHomePage += szEnglishHomepage;
	m_HyperHomePageLink.SetWindowText(szHomePage);
	m_HyperHomePageLink.SetURL(szEnglishHomepage);
	m_HyperHomePageLink.SetUnderline(FALSE);

	char szVersion[] = "PDF2Word version v1.4";
	SetWindowText(szVersion);
	GetDlgItem(IDC_VERSION)->SetWindowText(szVersion);

	m_szRegisterInfo.Format(
		"PDF2Word Version v1.4\r\n"
		"Register type: %s\r\n",
		IsRegistered?"Registered":"Unregister");
	m_szRegisterInfo += "\r\n";
	m_szRegisterInfo += "PDF2Word v1.4 is licensed under ";
	m_szRegisterInfo += "the GNU General Public License (GPL).  ";
	m_szRegisterInfo += "See the 'COPYING' file for details. \r\nPortions of ";
	m_szRegisterInfo += "this software are copyright 1996-2004 Glyph & Cog, LLC.\r\n";


	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void Cwin_pdf2rtfDlg::OnRButtonUp(UINT nFlags, CPoint point) 
{
	POINT	CurPos;
	GetCursorPos(&CurPos);
	CMenu *m_menuSub = GetMenu()->GetSubMenu(0);
	m_menuSub->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
		CurPos.x,CurPos.y+2,this);
//	CDialog::OnRButtonUp(nFlags, point);
}
BOOL Cwin_pdf2rtfDlg::MyCheckKeyDown(HWND hWnd,WPARAM wParam, LPARAM lParam)
{
	switch (wParam)
	{
	case VK_F1:
		OnHelpHelp();
		return TRUE;
	case VK_ESCAPE:
		OnFileExit();
		return TRUE;
	case 'F':
		if(GetKeyState(VK_CONTROL)&0x8000)
			OnFileOpen();
		return TRUE;
	case 'D':
		if(GetKeyState(VK_CONTROL)&0x8000)
			OnFilePreferences();
		return TRUE;
	case 'Q':
		if(GetKeyState(VK_CONTROL)&0x8000)
			OnFileExit();
		return TRUE;
	case 'T':
		if(GetKeyState(VK_CONTROL)&0x8000)
			OnFileTop();
		return TRUE;
	}
	return FALSE;
}

void Cwin_pdf2rtfDlg::OnHelpHelp() 
{
	ShellOpen("help.html");
}

void Cwin_pdf2rtfDlg::OnPause() 
{
	// TODO: Add your control notification handler code here
	CString m_strPause;
	GetDlgItem(IDPAUSE)->GetWindowText(m_strPause);
	if(m_strPause == "Pause")
	{
		SuspendThread(hNetBarThread);
		GetDlgItem(IDPAUSE)->SetWindowText("Resume");
		GetDlgItem(IDCLOSE)->EnableWindow(FALSE);
	}
	else if(m_strPause == "Resume")
	{
		ResumeThread(hNetBarThread);
		GetDlgItem(IDPAUSE)->SetWindowText("Pause");
		GetDlgItem(IDCLOSE)->EnableWindow(TRUE);
	}
}

void Cwin_pdf2rtfDlg::OnClose() 
{
	CString m_strClose;
	GetDlgItem(IDCLOSE)->GetWindowText(m_strClose);
	if(m_strClose == "Stop")
	{//ǰڴ
		if (MessageBox("Are you sure to stop?","PDF2Word",MB_YESNO)==IDYES)
		{
			//ҳжϱ־ֹͣǰļת
			m_bTerminateProcessPage = TRUE;
			//ļУֹʣPDFļĴ
			EnterCriticalSection(&nCriticalSection);
			m_aryPDF2HTMFile.RemoveAll();
			LeaveCriticalSection(&nCriticalSection);
		}
	}
	else if(m_strClose == "Close")
	{
		if(MessageBox("Do you want exit?","PDF2Word",MB_YESNO) == IDYES)
			ExitProcess(0);

	}
}
void Cwin_pdf2rtfDlg::OnHelpRegister() 
{
	IsRegistered = ShowRegisterDlg(IsRegistered,m_hWnd);
}

void Cwin_pdf2rtfDlg::WinHelp(DWORD dwData, UINT nCmd) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	//CDialog::WinHelp(dwData, nCmd);
}

void Cwin_pdf2rtfDlg::OnHelpProductlist() 
{
	ShellOpen("product.pdf");
}

void Cwin_pdf2rtfDlg::ShellOpen(LPCTSTR lpDoc)
{
	CHAR	szExeDir[MAX_PATH];
	GetModuleFileName(AfxGetInstanceHandle(),szExeDir,MAX_PATH);
	CHAR drive[_MAX_DRIVE],dir[_MAX_DIR],fname[_MAX_FNAME],ext[_MAX_EXT];
	_splitpath(szExeDir, drive, dir, fname, ext );
	_makepath(szExeDir, drive, dir,"","");
	if(szExeDir[strlen(szExeDir)-1] != '\\')
		strcat(szExeDir,"\\");
	strcat(szExeDir,lpDoc);
	ShellExecute(m_hWnd,"open",szExeDir,NULL,NULL,SW_SHOWNORMAL);
}

void Cwin_pdf2rtfDlg::OnHelpBuynow() 
{
	MyGotoURL(szEnglishRegister,SW_SHOWNORMAL);
}

void Cwin_pdf2rtfDlg::OnHelpPdf2htmOnweb() 
{
	MyGotoURL(szEnglishHomepage,SW_SHOWNORMAL);
}

void Cwin_pdf2rtfDlg::OnToolsPdf2htm() 
{
	UpdateTitle();
}

void Cwin_pdf2rtfDlg::OnToolsPdf2bmp() 
{
	UpdateTitle();
}


void Cwin_pdf2rtfDlg::OnTimer(UINT nIDEvent) 
{
	if(m_bWithoutShowMainWnd)
		ShowWindow(SW_HIDE);
	CDialog::OnTimer(nIDEvent);
}
LRESULT Cwin_pdf2rtfDlg::OnRTFWriting(WPARAM, LPARAM ptrMessage)
{
	if(ptrMessage)
	{
		char m_szMessage[300];
		memset(m_szMessage,0,300);
		GlobalGetAtomName(ptrMessage,m_szMessage,300);
		GetDlgItem(IDC_STATIC_TOTALPAGES)->SetWindowText(m_szMessage);
	}
	return 0;
}
